// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/08/08 
//
//-------------------------------------------------------------------
// DefectFilterGSDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// ACgp[^p_CAO
CAlignmentParamDlg *pParamDlg;


/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDefectFilterGSDlg _CAO

CDefectFilterGSDlg::CDefectFilterGSDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDefectFilterGSDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDefectFilterGSDlg)
	m_color = -1;
	m_imagelist = -1;
	m_errq = 30;
	m_atanthresh = 30;
	m_binlevel = 128;
	m_minsize = 5;
	m_maxsize = 245760;
	m_angle = 0.0;
	m_arrange = 0;
	m_wndtouch = FALSE;
	m_result = _T("");
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_blnVideoOpened = false;
	pFvxAlignmentPattern = NULL;
	pSearchArea = NULL;
	pMasterGSResult = NULL;
	m_masterXc = 0;
	m_masterYc = 0;
	m_masterAngle = 0;
	pParamDlg = NULL;
}

// fXgN^
CDefectFilterGSDlg::~CDefectFilterGSDlg()
{
	// CX^X̔j
	if (pFvxAlignmentPattern!=NULL) {
		delete[] pFvxAlignmentPattern;
		pFvxAlignmentPattern = NULL;
	}
	if (pSearchArea!=NULL) {
		delete[] pSearchArea;
		pSearchArea = NULL;
	}
	if (pMasterGSResult!=NULL) {
		delete[] pMasterGSResult;
		pMasterGSResult = NULL;
	}
	if (pParamDlg!=NULL) {
		delete pParamDlg;
		pParamDlg = NULL;
	}
}

void CDefectFilterGSDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDefectFilterGSDlg)
	DDX_CBIndex(pDX, IDC_COLOR, m_color);
	DDX_CBIndex(pDX, IDC_IMGLIST, m_imagelist);
	DDX_Text(pDX, IDC_ERRQ, m_errq);
	DDV_MinMaxInt(pDX, m_errq, 0, 180);
	DDX_Text(pDX, IDC_ATANTHRESH, m_atanthresh);
	DDV_MinMaxInt(pDX, m_atanthresh, 0, 180);
	DDX_Text(pDX, IDC_BINLEVEL, m_binlevel);
	DDV_MinMaxInt(pDX, m_binlevel, 0, 255);
	DDX_Text(pDX, IDC_MINSIZE, m_minsize);
	DDX_Text(pDX, IDC_MAXSIZE, m_maxsize);
	DDX_Text(pDX, IDC_ANGLE, m_angle);
	DDV_MinMaxDouble(pDX, m_angle, -180., 180.);
	DDX_Radio(pDX, IDC_ARRANGE0, m_arrange);
	DDX_Check(pDX, IDC_WNDTOUCH, m_wndtouch);
	DDX_Text(pDX, IDC_RESULT, m_result);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDefectFilterGSDlg, CDialog)
	//{{AFX_MSG_MAP(CDefectFilterGSDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_CLEAROVERLAY, OnClearoverlay)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_GRAB, OnGrab)
	ON_BN_CLICKED(IDC_LOADIMAGE, OnLoadimage)
	ON_BN_CLICKED(IDC_SAVEIMAGE, OnSaveimage)
	ON_BN_CLICKED(IDC_SAVEBMPWOL, OnSavebmpwol)
	ON_CBN_SELCHANGE(IDC_IMGLIST, OnSelchangeImglist)
	ON_BN_CLICKED(IDC_EXECUTE, OnExecute)
	ON_BN_CLICKED(IDC_SETALIGNMENTPARAM, OnSetalignmentparam)
	ON_BN_CLICKED(IDC_SETMASTERIMG, OnSetmasterimg)
	ON_BN_CLICKED(IDC_EXESMPL, OnExesmpl)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDefectFilterGSDlg bZ[W nh

BOOL CDefectFilterGSDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	/* -------------------------------------------------------------------------------- */
	// FvxSample 
	CLicenceDlg dlg;
	CConfFileDlg fdlg;

	// CZXʂ̕\
	if (dlg.DoModal() == IDOK){

		//Ӂ
		// ߂COM̏sƂYȂłB
		CoInitialize(NULL);
		CWnd *pwnd ;
		IUnknown *p_unknown;
		long err_no = 0;

		// _CAOɓ\tĂFvxDisplayEx̃CX^X擾AX}[g|C^Ɋt܂B
		pwnd = GetDlgItem(IDC_FVXDISPLAYEX1);		// FvxDisplayEx̃nh擾
		p_unknown = pwnd->GetControlUnknown();		// Rg[̎IUnknownC^[tFCX擾
		p_unknown->QueryInterface(__uuidof(IFvxDisplayEx2Ptr),(void**)&m_FvxDisplayEx);

		// eFvxRg[̃CX^X𐶐܂B
		// w肷NXԈႦȂ悤ӂĂB
		m_FvxPerformanceCounter.CreateInstance( __uuidof( FvxPerformanceCounter ) ); 
		m_FvxFileAccess.CreateInstance( __uuidof( FvxFileAccess ) ); 
		m_FvxVideo.CreateInstance( __uuidof( FvxVideo ) ); 
		m_FvxChangeImage.CreateInstance( __uuidof( FvxChangeImage ) );
		m_FvxCorrelation1.CreateInstance( __uuidof( FvxCorrelation ) );
		m_FvxCorrelation2.CreateInstance( __uuidof( FvxCorrelation ) );
		m_FvxAffine.CreateInstance( __uuidof( FvxAffine ) ); 
		m_FvxBlob.CreateInstance( __uuidof( FvxBlob ) ); 
		m_FvxDefectFilter.CreateInstance( __uuidof( FvxDefectFilter ) ); 
		m_FvxROI.CreateInstance( __uuidof( FvxROI ) ); 
		m_FvxTempImage1.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxGrabImage.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxOrgImage.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxMasterImage.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxAlignedImage.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxDiffImage.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxBinImage.CreateInstance( __uuidof( FvxImage ) ); 
	
		// zŃCX^X𐶐
		pFvxAlignmentPattern = new IFvxPattern2Ptr[2] ;
		pSearchArea = new IFvRectangle2Ptr[2] ;
		pMasterGSResult = new IFvSearchResultPtr[2] ;

		for ( int i = 0; i < 2 ; i++) {
			pFvxAlignmentPattern[i].CreateInstance(__uuidof( FvxPattern ));
			pSearchArea[i].CreateInstance(__uuidof( FvRectangle ));
			pMasterGSResult[i].CreateInstance(__uuidof( FvSearchResult ));
		}
		// fBXvC̏
		m_FvxDisplayEx->CreateDisplay(1,0);

		// ϐ
		m_blnMakeMaster = false;
		m_blnVideoOpened = false;

		// J荞ݖ
		GetDlgItem( IDC_GRAB )->EnableWindow( FALSE );

		pSearchArea[0]->Putxs( -1 );
		pSearchArea[0]->Putys( -1 );
		pSearchArea[0]->Putxe( -1 );
		pSearchArea[0]->Putye( -1 );
		pSearchArea[1]->Putxs( -1 );
		pSearchArea[1]->Putys( -1 );
		pSearchArea[1]->Putxe( -1 );
		pSearchArea[1]->Putye( -1 );

		// Rg[ނ̏
		CComboBox*    pcmb;

		// Fݒ
		pcmb = ( CComboBox* )GetDlgItem( IDC_COLOR );
		pcmb->AddString( "BLACK" );
		pcmb->AddString( "WHITE" );
		m_color = 1;
		
		pcmb = ( CComboBox* )GetDlgItem( IDC_IMGLIST );
		pcmb->AddString( "荞݉摜" );
		pcmb->AddString( "Ώۉ摜" );
		pcmb->AddString( "摜" );
		pcmb->AddString( "ACgς Ώۉ摜" );
		pcmb->AddString( "rʉ摜" );
		pcmb->AddString( "ʂQl摜" );
		m_imagelist = 0 ;

		// p[^ݒʐ
		pParamDlg = new CAlignmentParamDlg();
		pParamDlg->Create( IDD_ALIGNMENTPARAM_DIALOG );
		pParamDlg->ShowWindow( SW_HIDE );
		pParamDlg->pMainDlg = this;
		pParamDlg->InitPtn();


		UpdateData( FALSE );

		// rfIݒt@C̑I
		fdlg.DoModal();

		if ( fdlg.m_check == FALSE ) {
			
		    // rfIݒt@CR|[lgɐݒ
 			m_FvxVideo->PutVideoConfFile( _bstr_t( fdlg.m_conffile ) );

			// rfIfoCXI[v
			try {

				m_FvxVideo->OpenDevice();

			} catch( _com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfIfoCX̃I[vɎs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
			}

			// VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
			// ̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
			// {vOł͊ȗ̂߂ɁAꗥ350ms̃ZbgAbv^CmۂĂ܂A
			// g̃Lv`{[hɍ킹ĕύXĂB
			::Sleep(350);

            // GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
            // 炩ChangeImageSize\bhɂImagẽTCYύXĂ
            // i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
			m_FvxVideo->ChangeImageSize( m_FvxGrabImage );
			ResizeImages();
			try	{

				// 捞
				m_FvxVideo->GrabSync( m_FvxGrabImage );

			} catch(_com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfI̎捞Ɏs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B

			}

			// J荞ݗL
			GetDlgItem(IDC_GRAB)->EnableWindow(TRUE);
			// rfIfoCX̏ԂL
			m_blnVideoOpened = true;

		}

		// 摜̕\
		m_FvxDisplayEx->DrawImage( m_FvxGrabImage );

	}else{

		// ӂĂ炦Ȃ瑦I
		EndDialog( IDCANCEL );
	}

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B

}

void CDefectFilterGSDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CDefectFilterGSDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CDefectFilterGSDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// 摜TCY낦
void CDefectFilterGSDlg::ResizeImages()
{
    long width = m_FvxGrabImage->GetImageWidth();
    long height = m_FvxGrabImage->GetImageHeight();
    
    m_FvxMasterImage->PutImageWidth( width );
    m_FvxMasterImage->PutImageHeight( height );
    m_FvxOrgImage->PutImageWidth( width );
    m_FvxOrgImage->PutImageHeight( height );
    m_FvxAlignedImage->PutImageWidth( width );
    m_FvxAlignedImage->PutImageHeight( height );
    m_FvxDiffImage->PutImageWidth( width );
    m_FvxDiffImage->PutImageHeight( height );
    m_FvxBinImage->PutImageWidth( width );
    m_FvxBinImage->PutImageHeight( height );

}

void CDefectFilterGSDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
    // rfIfoCXI[vĂꍇ̓N[Y܂
	if ( m_blnVideoOpened == true ) {
		m_FvxVideo->CloseDevice();	
	}
	
}

void CDefectFilterGSDlg::OnClearoverlay() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	m_FvxDisplayEx->ClearOverlay( -1 );
}

// T[`GA̐ݒ
void CDefectFilterGSDlg::SetSearchArea(int index, IFvRectangle2Ptr pArea)
{
	pSearchArea[index]->Putxs( pArea->Getxs() );
	pSearchArea[index]->Putys( pArea->Getys() );
	pSearchArea[index]->Putxe( pArea->Getxe() );
	pSearchArea[index]->Putye( pArea->Getye() );
	pSearchArea[index]->Putye( pArea->Getye() );
    pSearchArea[index]->Putrotation_cent_x( 0 );
    pSearchArea[index]->Putrotation_cent_y( 0 );
    pSearchArea[index]->Putangle( 0 );
    
    m_FvxCorrelation1->SetInspectArea( pSearchArea[0] );
    m_FvxCorrelation2->SetInspectArea( pSearchArea[1] );

}

// T[`GA̎擾
void CDefectFilterGSDlg::GetSearchArea( int index, IFvRectangle2Ptr pArea)
{
    pArea->Putxs( pSearchArea[index]->Getxs() );
    pArea->Putys( pSearchArea[index]->Getys() );
    pArea->Putxe( pSearchArea[index]->Getxe() );
    pArea->Putye( pSearchArea[index]->Getye() );
    pArea->Putrotation_cent_x( 0 );
    pArea->Putrotation_cent_y( 0 );
    pArea->Putangle( 0 );
}

void CDefectFilterGSDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	if (IsIconic() == 0 ) {

		if ( m_FvxDisplayEx != NULL ){

			CWnd *pwnd;
			CRect rect;

			pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );
			pwnd->GetWindowRect( rect );

			// XN[WNCAgWɕϊ
			ScreenToClient( rect );

			// FvxDisplayEx̃TCYύX
			pwnd->MoveWindow( rect.left , rect.top, cx - (rect.left + 20) , cy - (rect.top + 20) , TRUE );

		}
	}
}

// J摜捞
void CDefectFilterGSDlg::OnGrab() 
{
    m_FvxVideo->GrabSync( m_FvxGrabImage );		// 捞
    m_FvxDisplayEx->DrawImage( m_FvxGrabImage );

}

void CDefectFilterGSDlg::OnLoadimage() 
{

	// R_CAONX̐
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg (TRUE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		m_FvxFileAccess->PutFilePath( _bstr_t(cFileDlg.GetPathName()));

		try {
		
			m_FvxFileAccess->LoadBitmap( m_FvxGrabImage );
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("Ǎ݂Ɏs܂Berr_no = %d", lngErr );
			MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
			return;
		}

		m_imagelist = 0;
		m_FvxDisplayEx->DrawImage( m_FvxGrabImage );
		ResizeImages();
		UpdateData( FALSE );
	}
}

void CDefectFilterGSDlg::OnSaveimage() 
{

	UpdateData( TRUE );

	// R_CAONX̐
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		m_FvxFileAccess->PutFilePath ( _bstr_t( cFileDlg.GetPathName() ));

		try {
		
			switch ( m_imagelist )
			{
				case 0:	// 荞݉摜
					m_FvxFileAccess->SaveBitmap( m_FvxGrabImage );
					break;
				case 1: // Ώۉ摜
					m_FvxFileAccess->SaveBitmap( m_FvxOrgImage );
					break;
				case 2: // 摜
					m_FvxFileAccess->SaveBitmap( m_FvxMasterImage );
					break;
				case 3: // ACgς݌Ώۉ摜
					m_FvxFileAccess->SaveBitmap( m_FvxAlignedImage );
					break;
				case 4: // rʉ摜
					m_FvxFileAccess->SaveBitmap( m_FvxDiffImage );
					break;
				case 5: // ʂQl摜
					m_FvxFileAccess->SaveBitmap( m_FvxBinImage );
					break;
			}
			
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("ۑɎs܂Berr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
	
}

// I[o[C܂߂āA\摜ۑ
void CDefectFilterGSDlg::OnSavebmpwol() 
{
	// R_CAONX̐
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		try {
		
			m_FvxDisplayEx->SaveBitmap( _bstr_t( cFileDlg.GetPathName() ) );
			
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxDisplayEx->GetErrReport( &lngErr );
			cStr.Format("ۑɎs܂Berr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
	
}

// \摜̐؂ւ
void CDefectFilterGSDlg::OnSelchangeImglist() 
{

	UpdateData( TRUE );

	switch ( m_imagelist )
	{
		case 0:	// 荞݉摜
			m_FvxDisplayEx->DrawImage( m_FvxGrabImage );
			break;
		case 1: // Ώۉ摜
			m_FvxDisplayEx->DrawImage( m_FvxOrgImage );
			break;
		case 2: // 摜
			m_FvxDisplayEx->DrawImage( m_FvxMasterImage );
			break;
		case 3: // ACgς݌Ώۉ摜
			m_FvxDisplayEx->DrawImage( m_FvxAlignedImage );
			break;
		case 4: // rʉ摜
			m_FvxDisplayEx->DrawImage( m_FvxDiffImage );
			break;
		case 5: // ʂQl摜
			m_FvxDisplayEx->DrawImage( m_FvxBinImage );
			break;
	}

}

// p[^̓Kp
bool CDefectFilterGSDlg::UpdateDataChk()
{

    
    if (!UpdateData(TRUE)) return false;

    // FvxDefectFilter lErrQ
    if (( m_errq < 0 ) || ( m_errq > 180 )) {
		MessageBox("lErrQɂ0`180̐lw肵ĂB" , "p[^G[", MB_ICONWARNING | MB_OK);
        return false;
	}
	m_FvxDefectFilter->PutlErrQ( m_errq );
    
    // FvxDefectFilter lAtanThresh
    if (( m_atanthresh < 0 ) || ( m_atanthresh  > 180 )) {
		MessageBox("lAtanThreshɂ0`180̐lw肵ĂB" , "p[^G[", MB_ICONWARNING | MB_OK);
        return false;
	}
	m_FvxDefectFilter->PutlAtanThresh( m_atanthresh );
    
    // ʐϒl`FbN
    if ( m_minsize < 1 ) {
		MessageBox("ŏʐϒl͂Pȏ̐lݒ肵Ă" , "p[^G[", MB_ICONWARNING | MB_OK);
        return false;
	}
		
	if ( m_minsize  >= m_maxsize ) {
		MessageBox("ŏʐϒlőʐϒlƂȂ悤ݒ肵Ă" , "p[^G[", MB_ICONWARNING | MB_OK);
        return false;
	}
		
    // őEŏʐϐݒ
    m_FvxBlob->PutMinSize( m_minsize );
    m_FvxBlob->PutMaxSize( m_maxsize );
    
    // ]p
    if (( m_angle < -180 ) || ( m_angle > 180 )) {
		MessageBox("]p -180.0`180.0 ͈̔͂œ͂Ă" , "p[^G[", MB_ICONWARNING | MB_OK);
        return false;
	}
	m_FvxBlob->Putangle( m_angle );
    
    // ΏېFݒ
    m_FvxBlob->PutColor ( (COLOR_TYPE ) m_color );

    // xOiojݒ
    m_FvxBlob->PutArrange( (ARRANGE_TYPE) m_arrange);

    // ͈͐ڐG
    if ( m_wndtouch == 1 ) {
        m_FvxBlob->PutWindowTouch(ON);
	} else {
        m_FvxBlob->PutWindowTouch(OFF);
	}
				
    return true;
}

// s
void CDefectFilterGSDlg::OnExecute() 
{
    
	// 摜o^Ă邩ǂ`FbN
    if ( m_blnMakeMaster != true ) {
		MessageBox("摜o^Ă܂" , "", MB_ICONWARNING | MB_OK);
		return;
	}
		
    // p[^Kp
    if ( UpdateDataChk() != true ){
		return;
	}
			
    if (( m_binlevel < 0 ) || ( m_binlevel > 255 )) {
		MessageBox("Ql臒l0`255͈̔͂Őݒ肵Ă" , "", MB_ICONWARNING | MB_OK);
		return;
	}
        
    m_result = "";
    
	// p^Đݒ
    m_FvxCorrelation1->SetPattern( pFvxAlignmentPattern[0] );
    m_FvxCorrelation2->SetPattern( pFvxAlignmentPattern[1] );
    
    // 荞ݗpobt@AΏۉ摜obt@ɃRs[
    m_FvxGrabImage->CopyTo( m_FvxOrgImage );
    
    m_FvxPerformanceCounter->StartCount();
    
    // ACg}[N@T[`s
	IFvSearchResultPtr pfvGSResult1(__uuidof(FvSearchResult));
	IFvSearchResultPtr pfvGSResult2(__uuidof(FvSearchResult));
    
	long lngCount = 0;
	m_FvxCorrelation1->Execute( m_FvxOrgImage, &lngCount );
    if ( lngCount > 0 ) {
        m_FvxCorrelation1->GetResult( 0, pfvGSResult1 );
	}
			
    m_FvxCorrelation2->Execute( m_FvxOrgImage, &lngCount );
    if ( lngCount > 0 ) {
        m_FvxCorrelation2->GetResult( 0, pfvGSResult2 );
	}
			
	double dblTotalExeTime = 0;
    double dblExeTime = 0;
	m_FvxPerformanceCounter->StopCount( &dblExeTime );
    m_result.Format("T[`: %2.fms",dblExeTime);

    dblTotalExeTime = dblExeTime;
    
    m_FvxPerformanceCounter->StartCount();
    
    // Q̃T[`ʂ̒_WƁAXp߂
    double xc = (pfvGSResult1->Getx() + pfvGSResult2->Getx()) / 2;
    double yc = (pfvGSResult1->Gety() + pfvGSResult2->Gety()) / 2;
    double dx = pfvGSResult2->Getx() - pfvGSResult1->Getx();
    double dy = pfvGSResult2->Gety() - pfvGSResult1->Gety();
    double angle = ArcTan(dx, dy);
    
    // ʒuƂ̍߂
    dx = xc - m_masterXc;
    dy = yc - m_masterYc;
    double dangle = -(angle - m_masterAngle);
    
    IFvMovementPtr pfvMove(__uuidof( FvMovement ));
	IFvPointPtr pfvpt(__uuidof( FvPoint )); 

	pfvMove->Putx( dx );
    pfvMove->Puty( dy );
    pfvpt->Putx( xc );
    pfvpt->Puty( yc );
    
    // WA\L̊pxlx\LɕύX
    double dangle_deg = dangle * 180 / 3.1415926535;
	if ( dangle_deg < 0 ) {
        dangle_deg = 360 + dangle_deg;
	}
			
    // 摜ACg
	m_FvxAffine->Rotation( m_FvxOrgImage, m_FvxTempImage1, dangle_deg, pfvpt );
    m_FvxAffine->Shift( m_FvxTempImage1, m_FvxAlignedImage, pfvMove );
    m_FvxPerformanceCounter->StopCount( &dblExeTime );
    CString szStr;
	szStr.Format("\r\nACg: %2.fms",dblExeTime );
	m_result = m_result + szStr;
	dblTotalExeTime = dblTotalExeTime + dblExeTime;
    
    m_FvxPerformanceCounter->StartCount();
    
    // 
    m_FvxDefectFilter->DefectFilter( m_FvxAlignedImage, m_FvxMasterImage, m_FvxDiffImage );
    m_FvxPerformanceCounter->StopCount( &dblExeTime );
    szStr.Format("\r\n: %2.fms",dblExeTime);
	m_result = m_result + szStr;
	dblTotalExeTime = dblTotalExeTime + dblExeTime;
    
    m_FvxPerformanceCounter->StartCount();
    
    // I[o[C
    m_FvxDisplayEx->ClearOverlay( -1 );
    
    m_FvxPerformanceCounter->StartCount();
    
    // Ql
    m_FvxChangeImage->FixedLevel( m_FvxDiffImage, m_FvxBinImage, m_binlevel );
    
    m_FvxPerformanceCounter->StopCount( &dblExeTime );
    szStr.Format("\r\nQl: %2.fms",dblExeTime);
	m_result = m_result + szStr;
    dblTotalExeTime = dblTotalExeTime + dblExeTime;
    
    m_FvxPerformanceCounter->StartCount();

    //Qlʒo
    IFvBlobResultGroup3Ptr pfvBlobResultG(__uuidof(FvBlobResultGroup));
	m_FvxBlob->Execute( m_FvxBinImage, &lngCount );
    if ( lngCount > 0 ) {
        m_FvxBlob->GetResult( -1, pfvBlobResultG );
        m_FvxDisplayEx->PutPenColor( RGB(255, 0, 0) );
        m_FvxDisplayEx->DrawData( 0, pfvBlobResultG );
	}
		
    m_FvxPerformanceCounter->StopCount( &dblExeTime );
    szStr.Format("\r\nʌv: %2.fms",dblExeTime);
	m_result = m_result + szStr;
	dblTotalExeTime = dblTotalExeTime + dblExeTime;
    szStr.Format("\r\nTotal: %2.fms",dblTotalExeTime);
	m_result = m_result + szStr;
    
    // \Ql摜ɐ؂ւ
    m_imagelist = 5;
	UpdateData(FALSE);
	OnSelchangeImglist();
    m_FvxDisplayEx->DrawImage( m_FvxBinImage );
	UpdateData(FALSE);
	
}

// -΁`΂܂ŌvZł悤Atng
double CDefectFilterGSDlg::ArcTan(double dbl_x, double dbl_y)
{

	const double PI = 3.14159265358979;

    if ( dbl_x > 0 ) {
        return  atan(dbl_y / dbl_x);
	} else {
		if ( dbl_y > 0 ) {
            return  PI - atan(dbl_y / -dbl_x);
		} else {
			return atan (-dbl_y / -dbl_x) - PI;
		}
	}
}

// ACgݒ_CAO\
void CDefectFilterGSDlg::OnSetalignmentparam() 
{

	pParamDlg->PtnView();
	pParamDlg->ShowWindow( SW_SHOW );

}

// \}[N\
void CDefectFilterGSDlg::drawCrossMark(long layerno, double x, double y)
{
 
	IFvLineSegmentPtr pfvLineSeg(__uuidof(FvLineSegment));
    const int length = 5;
	
	pfvLineSeg->Putxs( x - length );
	pfvLineSeg->Putxe( x + length );
	pfvLineSeg->Putys( y );
	pfvLineSeg->Putye( y );
    m_FvxDisplayEx->DrawData( layerno, pfvLineSeg );

	pfvLineSeg->Putxs( x );
	pfvLineSeg->Putxe( x );
	pfvLineSeg->Putys( y - length );
	pfvLineSeg->Putye( y + length );
    m_FvxDisplayEx->DrawData( layerno, pfvLineSeg );

}

// 摜o^
void CDefectFilterGSDlg::OnSetmasterimg() 
{

   	IFvLineSegmentPtr pfvLineSeg(__uuidof(FvLineSegment));

    // p^Đݒ
	try {
		m_FvxCorrelation1->SetPattern( pFvxAlignmentPattern[0] );
		m_FvxCorrelation2->SetPattern( pFvxAlignmentPattern[1] );
	} catch(_com_error ) {
		MessageBox("ACgp^o^Ă܂B" , "" , MB_ICONWARNING | MB_OK );
		return;
	}
    
    // 荞ݗpobt@A摜obt@ɃRs[
    m_FvxGrabImage->CopyTo( m_FvxMasterImage );
    
    // ACg}[N@T[`s
    long lngCount = 0;
	m_FvxCorrelation1->Execute( m_FvxMasterImage, &lngCount );
    if ( lngCount == 0 ) {
		MessageBox("ACgp^܂łB","" , MB_ICONWARNING | MB_OK );
		return;
	}
	m_FvxCorrelation1->GetResult( 0, pMasterGSResult[0] );
    
    m_FvxCorrelation2->Execute( m_FvxMasterImage, &lngCount );
    if ( lngCount == 0 ) {
		MessageBox("ACgp^܂łB","" , MB_ICONWARNING | MB_OK );
		return;
	}
	m_FvxCorrelation2->GetResult( 0, pMasterGSResult[1] );
    
    // Q̃T[`ʂ̒_WƁAXp߂
    m_masterXc = (pMasterGSResult[0]->Getx() + pMasterGSResult[1]->Getx()) / 2;
    m_masterYc = (pMasterGSResult[0]->Gety() + pMasterGSResult[1]->Gety()) / 2;
    double dx = pMasterGSResult[1]->Getx() - pMasterGSResult[0]->Getx();
    double dy = pMasterGSResult[1]->Gety() - pMasterGSResult[0]->Gety();
    m_masterAngle = ArcTan(dx, dy);
    
    // \摜摜ɐ؂ւ
    m_imagelist = 2;
   	UpdateData(FALSE);
	OnSelchangeImglist();

    // I[o[CɃT[`ʂ\
    m_FvxDisplayEx->ClearOverlay( -1 );
    m_FvxDisplayEx->PutPenColor( RGB(128, 128, 255) );
    pfvLineSeg->Putxs( pMasterGSResult[0]->Getx() );
    pfvLineSeg->Putys( pMasterGSResult[0]->Gety() );
    pfvLineSeg->Putxe( pMasterGSResult[1]->Getx() );
    pfvLineSeg->Putye( pMasterGSResult[1]->Gety() );
    m_FvxDisplayEx->DrawData( 0, pfvLineSeg );
    
    m_FvxDisplayEx->PutPenColor(RGB(255, 0, 0));
    m_FvxDisplayEx->DrawData( 0, pMasterGSResult[0] );
    m_FvxDisplayEx->DrawData( 0, pMasterGSResult[1] );
    drawCrossMark( 0, m_masterXc, m_masterYc );
    
    // 摜o^ς݃tO𗧂Ă
    m_blnMakeMaster = true;
	
}

// Tvs
void CDefectFilterGSDlg::OnExesmpl() 
{

	long lngErr = 0;

	if (!UpdateData(TRUE)) {
		return ;
	}

	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CString sFilePath = szIniFilePath;
	sFilePath.Replace("DefectFilterGS.exe","pcb_smp1.bmp");

    // 摜ǂݍ
    m_FvxFileAccess->PutFilePath( _bstr_t(sFilePath) );
	try {
		m_FvxFileAccess->LoadBitmap( m_FvxGrabImage );
    } catch (_com_error) {
		m_FvxFileAccess->GetErrReport(&lngErr);
		MessageBox("摜(pcb_smp1.bmp)̓ǂݍ݂Ɏs܂","" , MB_ICONWARNING | MB_OK );
		return;
	}
	m_FvxDisplayEx->DrawImage( m_FvxGrabImage );
    m_imagelist = 0;
	UpdateData(FALSE);
	OnSelchangeImglist();
	MessageBox("摜(pcb_smp1.bmp)ǂݍ","" , MB_ICONWARNING | MB_OK );
    
    // ACgp^ǂݍ
	sFilePath.Replace("pcb_smp1.bmp","pat1.pat");
    pFvxAlignmentPattern[0]->PutLoadPattrenFileName ( _bstr_t( sFilePath ) );
	try {
	    pFvxAlignmentPattern[0]->Load();
    } catch (_com_error) {
		pFvxAlignmentPattern[0]->GetErrReport(&lngErr);
		MessageBox("p^ǂݍ݂Ɏs܂","" , MB_ICONWARNING | MB_OK );
		return;
	}
	sFilePath.Replace("pat1.pat","pat2.pat");
    pFvxAlignmentPattern[1]->PutLoadPattrenFileName ( _bstr_t( sFilePath ) );
	try {
	    pFvxAlignmentPattern[1]->Load();
    } catch (_com_error) {
		pFvxAlignmentPattern[1]->GetErrReport(&lngErr);
		MessageBox("p^ǂݍ݂Ɏs܂","" , MB_ICONWARNING | MB_OK );
		return;
	}

	pParamDlg->PtnView();
	pParamDlg->ShowWindow( SW_SHOW );
	MessageBox("p^ǂݍ","" , MB_ICONWARNING | MB_OK );
	pParamDlg->ShowWindow( SW_HIDE );

    // 摜o^
    OnSetmasterimg();
	MessageBox("摜o^","" , MB_ICONWARNING | MB_OK );
    
    // Ώۉ摜ǂݍ
	sFilePath.Replace("pat2.pat","pcb_smp2.bmp");
    m_FvxFileAccess->PutFilePath( _bstr_t( sFilePath ));
	try {
	    m_FvxFileAccess->LoadBitmap( m_FvxGrabImage );
    } catch (_com_error) {
		m_FvxFileAccess->GetErrReport(&lngErr);
		MessageBox("Ώۉ摜(pcb_smp2.bmp)ǂݍ݂Ɏs܂","" , MB_ICONWARNING | MB_OK );
		return;
	}
    m_FvxDisplayEx->DrawImage( m_FvxGrabImage );
    m_imagelist = 0;
	UpdateData(FALSE);
	OnSelchangeImglist();
	MessageBox("Ώۉ摜(pcb_smp2.bmp)ǂݍ","" , MB_ICONWARNING | MB_OK );
    
    m_binlevel = 60;
    
    // s
    m_atanthresh = 0;
    m_errq = 0;
    OnExecute();
	MessageBox("lAtanThresh=0\r\nlErrQ=0\r\ns","" , MB_ICONWARNING | MB_OK );
    
    m_atanthresh = 30;
    m_errq = 30;
    OnExecute();
	MessageBox("lAtanThresh=30\r\nlErrQ=30\r\ns","" , MB_ICONWARNING | MB_OK );
	
}

void CDefectFilterGSDlg::ParamDlgHide()
{
	pParamDlg->ShowWindow( SW_HIDE );
	this->ShowWindow(SW_SHOWNORMAL);
}

BOOL CDefectFilterGSDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	if(pMsg->message == WM_KEYDOWN)
	{
		switch( pMsg->wParam )
		{
			case VK_RETURN:
			case VK_ESCAPE:
				return false;
		}
	}	
	return CDialog::PreTranslateMessage(pMsg);
}

